<script>
import { mapGetters } from 'vuex';

import AppBar from '~/components/ui/app-bar.vue';
import AppFooter from '~/components/ui/app-footer.vue';

export default {
  name: `layout-default`,
  components: {
    AppBar,
    AppFooter,
  },
  computed: {
    ...mapGetters('projects', [ 'activeProjects' ]),
  },
  methods: {
    closeDropdowns() {
      this.$refs.appbar.closeUserDropdown();
      this.$refs.appfooter.closeWebsocketsDropdown();
    }
  },
  async created() {
    if (this.$store.state.projects.projects === null) {
      await this.$store.dispatch(`projects/loadProjects`, { $axios: this.$axios });
    }
  },
}
</script>

<template>
  <v-app class="app" dark>
    <template v-if="!activeProjects">
      <v-container fill-height fluid>
        <v-row align="center" justify="center">
            <v-progress-circular indeterminate :size="80" color="white" />
        </v-row>
      </v-container>
    </template>
    <template v-else>
      <app-bar ref="appbar" :projects="activeProjects || []"></app-bar>
      <v-main app class="py-32" @click="closeDropdowns">
        <nuxt />
      </v-main>
      <notifications position="bottom right" animation-name="notifications-fade-right" classes="vue-notification" />
      <app-footer ref="appfooter"></app-footer>
    </template>
  </v-app>
</template>

<style lang="scss">
html {
  overflow-y: auto;
}

.app {
  height: 100%;
  width: 100vw;
}

.card {
  margin-bottom: 8px;
}

.v-navigation-drawer {
  z-index: 2 !important;
}
</style>
